/*-----------------------DROP---------------------*/
/*------------------------------------------------*/
/*
DROP TABLE DW_temps_incidencies_prio;
DROP TABLE DW_peticions_sobre_temps;
DROP TABLE DW_usuari_mes_incidencies;
DROP TABLE DW_top10_peticions_seu;
DROP TABLE DW_tickets_resolts_mes;
DROP TABLE DW_servei_peticions;
DROP TABLE DW_incidencies_seu_any;
DROP TABLE DW_hores_tickets_L3;
DROP TABLE DW_incidencies_PM;
DROP TABLE DW_sms_no_respostos;
DROP TABLE DW_tickets_tancats;
DROP TABLE DW_tickets_per_canal;
*/
/*----------------------CREATE--------------------*/
/*------------------------------------------------*/

CREATE TABLE DW_temps_incidencies_prio (
	mes INTEGER NOT NULL,
	ani INTEGER NOT NULL,
	prioritat INTEGER NOT NULL, 
	qtt_incidencies INTEGER NOT NULL,
	temps_total INTEGER NOT NULL,
	CONSTRAINT PK_DW_temps_incidencies_prio PRIMARY KEY (mes, ani, prioritat)
);

CREATE TABLE DW_peticions_sobre_temps (
	mes INTEGER NOT NULL,
	ani INTEGER NOT NULL,
	pais VARCHAR2 (50 CHAR) NOT NULL, 
	qtt_peticions INTEGER NOT NULL,
	qtt_peticions_sobre_temps INTEGER NOT NULL,
	CONSTRAINT PK_DW_peticions_sobre_temps PRIMARY KEY (mes, ani, pais)
);


CREATE TABLE DW_usuari_mes_incidencies (
	usuari VARCHAR2 (50 CHAR) NOT NULL,
	qtt_incidencies INTEGER NOT NULL,
	CONSTRAINT PK_DW_usuari_mes_incidencies PRIMARY KEY (usuari)
);

CREATE TABLE DW_top10_peticions_seu (
	seu VARCHAR2 (20 CHAR) NOT NULL,
	servei VARCHAR2 (20 CHAR) NOT NULL,
	qtt_peticions INTEGER NOT NULL,
	CONSTRAINT PK_DW_top10_peticions_seu PRIMARY KEY (seu, servei)
);

CREATE TABLE DW_tickets_resolts_mes (
	mes INTEGER NOT NULL,
	ani INTEGER NOT NULL,
	qtt_peticions INTEGER NOT NULL,
	CONSTRAINT PK_DW_tickets_resolts_mes PRIMARY KEY (mes, ani)
);

CREATE TABLE DW_servei_peticions (
	servei VARCHAR2 (20 CHAR) NOT NULL,
	qtt_peticions INTEGER NOT NULL,
	CONSTRAINT PK_DW_servei_peticions PRIMARY KEY (servei)
);

CREATE TABLE DW_incidencies_seu_any (
	ani INTEGER NOT NULL,
	seu VARCHAR2 (20 CHAR) NOT NULL,
	qtt_incidencies INTEGER NOT NULL,
	CONSTRAINT PK_DW_incidencies_seu_any PRIMARY KEY (ani, seu)
);

CREATE TABLE DW_hores_tickets_L3 (
	ani INTEGER NOT NULL,
	qtt_hores INTEGER NOT NULL,
	CONSTRAINT PK_DW_hores_tickets_L3 PRIMARY KEY (ani)
);

CREATE TABLE DW_incidencies_PM (
	ani INTEGER NOT NULL,
	qtt_incidencies INTEGER NOT NULL,
	CONSTRAINT PK_DW_incidencies_PM PRIMARY KEY (ani)
);

CREATE TABLE DW_sms_no_respostos (
	ani INTEGER NOT NULL,
	qtt_tickets INTEGER NOT NULL,
	qtt_tickets_no_respostos INTEGER NOT NULL,
	CONSTRAINT PK_DW_sms_no_respostos PRIMARY KEY (ani)
);

CREATE TABLE DW_tickets_tancats (
	qtt_tancats INTEGER NOT NULL,
	CONSTRAINT PK_DW_tickets_tancats PRIMARY KEY (qtt_tancats)
);

CREATE TABLE DW_tickets_per_canal (
	pais VARCHAR2 (50 CHAR) NOT NULL, 
	mes INTEGER NOT NULL,
	ani INTEGER NOT NULL,
	canal VARCHAR2 (20 CHAR) NOT NULL,
	qtt_tickets_canal INTEGER NOT NULL,
	qtt_tickets_total INTEGER NOT NULL,
	CONSTRAINT PK_DW_tickets_per_canal PRIMARY KEY (pais, mes, ani, canal)
);