/*-----------------------DROP----------------------*/
/*------------------------------------------------*/
/*
DROP PROCEDURE DW_temps_incidencies_prio_INC;
DROP PROCEDURE DW_temps_incidencies_prio_SEL;

DROP PROCEDURE DW_peticions_sobre_temps_INC;
DROP PROCEDURE DW_peticions_sobre_temps_SEL;

DROP PROCEDURE DW_usuari_mes_incidencies_INC;
DROP PROCEDURE DW_usuari_mes_incidencies_DEC;
DROP PROCEDURE DW_usuari_mes_incidencies_SEL;

DROP PROCEDURE DW_top10_peticions_seu_INC;
DROP PROCEDURE DW_top10_peticions_seu_DEC;
DROP PROCEDURE DW_top10_peticions_seu_SEL;

DROP PROCEDURE DW_tickets_resolts_mes_INC;
DROP PROCEDURE DW_tickets_resolts_mes_SEL;

DROP PROCEDURE DW_servei_peticions_INC;
DROP PROCEDURE DW_servei_peticions_DEC;
DROP PROCEDURE DW_servei_peticions_SEL;

DROP PROCEDURE DW_incidencies_seu_any_INC;
DROP PROCEDURE DW_incidencies_seu_any_DEC;
DROP PROCEDURE DW_incidencies_seu_any_SEL;

DROP PROCEDURE DW_hores_tickets_L3_INC;
DROP PROCEDURE DW_hores_tickets_L3_SEL;

DROP PROCEDURE DW_incidencies_PM_INC;
DROP PROCEDURE DW_incidencies_PM_DEC;
DROP PROCEDURE DW_incidencies_PM_SEL;

DROP PROCEDURE DW_sms_no_respostos_INC;
DROP PROCEDURE DW_sms_no_respostos_DEC;
DROP PROCEDURE DW_sms_no_respostos_SEL;

DROP PROCEDURE DW_tickets_tancats_INC;
DROP PROCEDURE DW_tickets_tancats_DEC;
DROP PROCEDURE DW_tickets_tancats_SEL;

DROP PROCEDURE DW_tickets_per_canal_INC;
DROP PROCEDURE DW_tickets_per_canal_DEC;
DROP PROCEDURE DW_tickets_per_canal_MOD;
DROP PROCEDURE DW_tickets_per_canal_SEL;
*/
/*----------------------UPDATE---------------------*/
/*------------------------------------------------*/

--DW_temps_incidencies_prio

CREATE OR REPLACE PROCEDURE DW_temps_incidencies_prio_INC (prioritat_in IN INTEGER, data_creacio_in IN TIMESTAMP) AS

temps_transcorregut INTEGER;

BEGIN
	--calculem el temps trancorregut (en segons) des de la creacio fins aquest moment
	temps_transcorregut := ((CAST (CURRENT_TIMESTAMP AS DATE) - CAST (data_creacio_in AS DATE)) * 86400);
	
	--UPDATE a DW_temps_incidencies_prio
	UPDATE DW_temps_incidencies_prio
	SET qtt_incidencies = qtt_incidencies+1, temps_total = temps_total + temps_transcorregut
	WHERE ani = to_char(sysdate, 'YYYY') AND mes = to_char(sysdate, 'MM') AND prioritat = prioritat_in;

	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_temps_incidencies_prio
		VALUES (to_char(sysdate, 'MM'), to_char(sysdate, 'YYYY'), prioritat_in, 1, temps_transcorregut);
	END IF;
	
END DW_temps_incidencies_prio_INC;
/

--DW_peticions_sobre_temps

CREATE OR REPLACE PROCEDURE DW_peticions_sobre_temps_INC (temps_mig_in IN INTEGER, data_creacio_in IN TIMESTAMP, pais_in IN VARCHAR2) AS
temps_transcorregut INTEGER;

BEGIN
	--calculem el temps trancorregut (en segons) des de la creaciÃ³ fins aquest moment
	temps_transcorregut := ((CAST (CURRENT_TIMESTAMP AS DATE) - CAST (data_creacio_in AS DATE)) * 86400);
	
	--UPDATE a DW_peticions_sobre_temps
	UPDATE DW_peticions_sobre_temps
	SET qtt_peticions = qtt_peticions+1
	WHERE ani = to_char(sysdate, 'YYYY') AND mes = to_char(sysdate, 'MM') AND pais = pais_in;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_peticions_sobre_temps
		VALUES (to_char(sysdate, 'MM'), to_char(sysdate, 'YYYY'), pais_in, 1, 0);
	END IF;
	
	--en cas que el temps transcorregut sigui superior al temps mig de resolucio, augmentem
	IF temps_transcorregut > temps_mig_in THEN
		UPDATE DW_peticions_sobre_temps
		SET qtt_peticions_sobre_temps = qtt_peticions_sobre_temps+1
		WHERE ani = to_char(sysdate, 'YYYY') AND mes = to_char(sysdate, 'MM') AND pais = pais_in;
	END IF;
	
END DW_peticions_sobre_temps_INC;
/

--DW_usuari_mes_incidencies

CREATE OR REPLACE PROCEDURE DW_usuari_mes_incidencies_INC (usuari_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_usuari_mes_incidencies
	SET qtt_incidencies = qtt_incidencies+1
	WHERE usuari = usuari_in;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_usuari_mes_incidencies
		VALUES (usuari_in, 1);
	END IF;
	
END DW_usuari_mes_incidencies_INC;
/

CREATE OR REPLACE PROCEDURE DW_usuari_mes_incidencies_DEC (usuari_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_usuari_mes_incidencies
	SET qtt_incidencies = qtt_incidencies-1
	WHERE usuari = usuari_in;
	
END DW_usuari_mes_incidencies_DEC;
/

--DW_top10_peticions_seu

CREATE OR REPLACE PROCEDURE DW_top10_peticions_seu_INC (seu_in IN VARCHAR2, servei_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_top10_peticions_seu
	UPDATE DW_top10_peticions_seu
	SET qtt_peticions = qtt_peticions+1
	WHERE seu = seu_in AND servei = servei_in;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_top10_peticions_seu
		VALUES (seu_in, servei_in, 1);
	END IF;
	
END DW_top10_peticions_seu_INC;
/

CREATE OR REPLACE PROCEDURE DW_top10_peticions_seu_DEC (seu_in IN VARCHAR2, servei_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_top10_peticions_seu
	UPDATE DW_top10_peticions_seu
	SET qtt_peticions = qtt_peticions-1
	WHERE seu = seu_in AND servei = servei_in;
	
END DW_top10_peticions_seu_DEC;
/

--DW_tickets_resolts_mes

CREATE OR REPLACE PROCEDURE DW_tickets_resolts_mes_INC AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_tickets_resolts_mes
	SET qtt_peticions = qtt_peticions+1
	WHERE ani = to_char(sysdate, 'YYYY') AND mes = to_char(sysdate, 'MM');
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_tickets_resolts_mes
		VALUES (to_char(sysdate, 'MM'), to_char(sysdate, 'YYYY'), 1);
	END IF;
	
END DW_tickets_resolts_mes_INC;
/

--DW_servei_peticions

CREATE OR REPLACE PROCEDURE DW_servei_peticions_INC (servei_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_servei_peticions
	SET qtt_peticions = qtt_peticions+1
	WHERE servei = servei_in;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_servei_peticions
		VALUES (servei_in, 1);
	END IF;
	
END DW_servei_peticions_INC;
/

CREATE OR REPLACE PROCEDURE DW_servei_peticions_DEC (servei_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_servei_peticions
	SET qtt_peticions = qtt_peticions-1
	WHERE servei = servei_in;
	
END DW_servei_peticions_DEC;
/

--DW_incidencies_seu_any

CREATE OR REPLACE PROCEDURE DW_incidencies_seu_any_INC (seu_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_incidencies_seu_any
	SET qtt_incidencies = qtt_incidencies+1
	WHERE ani = to_char(sysdate, 'YYYY') AND seu = seu_in;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_incidencies_seu_any
		VALUES (to_char(sysdate, 'YYYY'), seu_in, 1);
	END IF;
	
END DW_incidencies_seu_any_INC;
/

CREATE OR REPLACE PROCEDURE DW_incidencies_seu_any_DEC (seu_in IN VARCHAR2) AS
BEGIN
	
	--UPDATE a DW_usuari_mes_incidencies
	UPDATE DW_incidencies_seu_any
	SET qtt_incidencies = qtt_incidencies-1
	WHERE ani = to_char(sysdate, 'YYYY') AND seu = seu_in;
	
END DW_incidencies_seu_any_DEC;
/

--DW_hores_tickets_L3

CREATE OR REPLACE PROCEDURE DW_hores_tickets_L3_INC (data_assig_L3_in IN TIMESTAMP) AS
hores_invertides INTEGER;

BEGIN
	--calculem el temps trancorregut (en hores) des de lassignacio al grup L3 fins ara
	SELECT ROUND((CAST(CURRENT_TIMESTAMP AS DATE) - CAST(data_assig_l3_in AS DATE)) * 3600) INTO hores_invertides FROM dual;

	--UPDATE a DW_hores_tickets_L3
	UPDATE DW_hores_tickets_L3
	SET qtt_hores = qtt_hores + hores_invertides
	WHERE ani = to_char(sysdate, 'YYYY');
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_hores_tickets_L3
		VALUES (to_char(sysdate, 'YYYY'), hores_invertides);
	END IF;
	
END DW_hores_tickets_L3_INC;
/

--DW_incidencies_PM

CREATE OR REPLACE PROCEDURE DW_incidencies_PM_INC AS
BEGIN

	--UPDATE a DW_incidencies_PM
	UPDATE DW_incidencies_PM
	SET qtt_incidencies = qtt_incidencies+1
	WHERE ani = to_char(sysdate, 'YYYY');
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_incidencies_PM
		VALUES (to_char(sysdate, 'YYYY'), 1);
	END IF;
	
END DW_incidencies_PM_INC;
/

CREATE OR REPLACE PROCEDURE DW_incidencies_PM_DEC AS
BEGIN

	--UPDATE a DW_incidencies_PM
	UPDATE DW_incidencies_PM
	SET qtt_incidencies = qtt_incidencies-1
	WHERE ani = to_char(sysdate, 'YYYY');
	
END DW_incidencies_PM_DEC;
/

--DW_sms_no_respostos

CREATE OR REPLACE PROCEDURE DW_sms_no_respostos_INC AS
BEGIN

	--UPDATE a DW_sms_no_respostos
	UPDATE DW_sms_no_respostos
	SET qtt_tickets = qtt_tickets+1, qtt_tickets_no_respostos = qtt_tickets_no_respostos+1
	WHERE ani = to_char(sysdate, 'YYYY');
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_sms_no_respostos
		VALUES (to_char(sysdate, 'YYYY'), 1, 1);
	END IF;
	
END DW_sms_no_respostos_INC;
/

CREATE OR REPLACE PROCEDURE DW_sms_no_respostos_DEC AS
BEGIN

	--UPDATE a DW_sms_no_respostos
	UPDATE DW_sms_no_respostos
	SET qtt_tickets_no_respostos = qtt_tickets_no_respostos - 1
	WHERE ani = to_char(sysdate, 'YYYY');
	
END DW_sms_no_respostos_DEC;
/

--DW_tickets_tancats

CREATE OR REPLACE PROCEDURE DW_tickets_tancats_INC AS
BEGIN

	--UPDATE a DW_tickets_tancats
	UPDATE DW_tickets_tancats
	SET qtt_tancats = qtt_tancats+1;
	
	--INSERT INTO en cas que el registre no existis previamnet
	IF sql%rowcount = 0 THEN
		INSERT INTO DW_tickets_tancats
		VALUES (1);
	END IF;
	
END DW_tickets_tancats_INC;
/

CREATE OR REPLACE PROCEDURE DW_tickets_tancats_DEC AS
BEGIN

	--UPDATE a DW_tickets_tancats
	UPDATE DW_tickets_tancats
	SET qtt_tancats = qtt_tancats-1;
	
END DW_tickets_tancats_DEC;
/

--DW_tickets_per_canal

CREATE OR REPLACE PROCEDURE DW_tickets_per_canal_INC (pais_in IN VARCHAR2, canal_in IN VARCHAR2, noms_canals_in IN va_params)AS
existeix INTEGER;

BEGIN
	--comprovem si existeixen les entrades per aquell any/mes/pais
	SELECT COUNT(*) INTO existeix 
	FROM DW_tickets_per_canal
	WHERE ani = to_char(sysdate, 'YYYY') AND mes = to_char(sysdate, 'MM') AND pais = pais_in;
	
	IF existeix > 0 THEN
		--les entrades existeixen
		
		--+1 a qtt_tickets_total per aquell pais/any/mes
		UPDATE DW_tickets_per_canal
		SET qtt_tickets_total = qtt_tickets_total+1
		WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY');
	
	ELSE
		--no existeix l'entrada
		
		FOR n IN 1..noms_canals_in.count
		--creem tantes entrdes com canals hi hagi al sistema, amb qtt_tickets_total = 1
		LOOP
			INSERT INTO DW_tickets_per_canal
			VALUES (pais_in, to_char(sysdate, 'MM'), to_char(sysdate, 'YYYY'), noms_canals_in(n), 0, 1);
		END LOOP;		
	END IF;
	
	--finalment incrementem en 1 el canal pel que s'ha creat el ticket
	UPDATE DW_tickets_per_canal
		SET qtt_tickets_canal = qtt_tickets_canal+1
		WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY') AND canal = canal_in;
	
END DW_tickets_per_canal_INC;
/

CREATE OR REPLACE PROCEDURE DW_tickets_per_canal_DEC (pais_in IN VARCHAR2, canal_in IN VARCHAR2)AS
BEGIN
		
	-- -1 a qtt_tickets_total per aquell pais/any/mes
	UPDATE DW_tickets_per_canal
	SET qtt_tickets_total = qtt_tickets_total-1
	WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY');
	
	-- -1 pel canal pel que s'ha creat el ticket
	UPDATE DW_tickets_per_canal
		SET qtt_tickets_canal = qtt_tickets_canal-1
		WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY') AND canal = canal_in;
	
END DW_tickets_per_canal_DEC;
/

CREATE OR REPLACE PROCEDURE DW_tickets_per_canal_MOD (pais_in IN VARCHAR2, canal_antic_in IN VARCHAR2, canal_nou_in IN VARCHAR2) AS
BEGIN
		
	-- -1 a qtt_tickets_canal per aquell pais/any/mes i canal_antic
	UPDATE DW_tickets_per_canal
	SET qtt_tickets_canal = qtt_tickets_canal-1
	WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY') AND canal = canal_antic_in;
	
	-- +1 a qtt_tickets_canal per aquell pais/any/mes i canal_nou
	UPDATE DW_tickets_per_canal
		SET qtt_tickets_canal = qtt_tickets_canal+1
		WHERE pais = pais_in AND mes = to_char(sysdate, 'MM') AND ani = to_char(sysdate, 'YYYY') AND canal = canal_nou_in;
	
END DW_tickets_per_canal_MOD;
/

/*----------------------SELECT---------------------*/
/*------------------------------------------------*/

--1
CREATE OR REPLACE PROCEDURE DW_temps_incidencies_prio_SEL (mes_in IN INTEGER, ani_in IN INTEGER) AS
prio va_params;
temps va_params;

BEGIN

    SELECT prioritat, temps_total/qtt_incidencies BULK COLLECT INTO prio, temps
    FROM DW_temps_incidencies_prio
    WHERE mes = mes_in AND ani = ani_in;
    
    FOR indx IN 1.. prio.count
    LOOP
         dbms_output.put_line(prio(indx) || ' : ' || temps(indx));  
    END LOOP;
   
END DW_temps_incidencies_prio_SEL;
/

--2
CREATE OR REPLACE PROCEDURE DW_peticions_sobre_temps_SEL (mes_in IN INTEGER, ani_in IN INTEGER, pais_in IN VARCHAR2, RSP OUT INTEGER) AS
BEGIN

    SELECT (qtt_peticions_sobre_temps * 100 / qtt_peticions) INTO RSP 
	FROM DW_peticions_sobre_temps
	WHERE mes = mes_in AND ani = ani_in AND pais = pais_in;
  
    --Tractament Excepcions
    EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := NULL; --No existeix cap entrada per aquell mes/any/pais
        WHEN ZERO_DIVIDE THEN RSP := 0; --La qtt_peticions es 0 per aquell mes/any/pais
            
END DW_peticions_sobre_temps_SEL;
/

--3
CREATE OR REPLACE PROCEDURE DW_usuari_mes_incidencies_SEL (RSP OUT VARCHAR2) AS
BEGIN

    SELECT usuari INTO RSP 
    FROM (
        SELECT usuari 
        FROM DW_usuari_mes_incidencies
        ORDER BY qtt_incidencies DESC
    )
    WHERE ROWNUM = 1;
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := NULL; --No existeix cap entrada a la taula
   
END DW_usuari_mes_incidencies_SEL;
/

--4
CREATE OR REPLACE PROCEDURE DW_top10_peticions_seu_SEL (seu_in IN VARCHAR2) AS
ser va_params;
pet va_params;

BEGIN

    SELECT servei, QTT_PETICIONS BULK COLLECT INTO ser, pet
    FROM (
        SELECT servei, QTT_PETICIONS 
        FROM DW_top10_peticions_seu
        WHERE seu = seu_in
        ORDER BY qtt_peticions DESC
    )
    WHERE ROWNUM <= 10;
        
    FOR indx IN 1..ser.count
    LOOP    
        dbms_output.put_line(ser(indx) || ' : ' || pet(indx));   
    END LOOP;
   
END DW_top10_peticions_seu_SEL;
/

--5
CREATE OR REPLACE PROCEDURE DW_tickets_resolts_mes_SEL (RSP OUT INTEGER) AS
	any_temp INTEGER;
    mes_temp INTEGER;
    tickets_mes_actual INTEGER;
    tickets_mes_anterior INTEGER;
BEGIN

    --seleccionem la quantitat de ticktes del mes i l`any actuals
    SELECT to_char(sysdate, 'YYYY') INTO any_temp FROM dual;     
    SELECT to_char(sysdate, 'MM') INTO mes_temp FROM dual;
		
    SELECT qtt_peticions INTO tickets_mes_actual 
    FROM DW_tickets_resolts_mes 
    WHERE ani = any_temp AND mes = mes_temp;
		
    --seleccionem la quantitat de ticktes del mes i l`any anteriors	
    mes_temp := mes_temp-1;
		
    IF mes_temp = 0 THEN
        mes_temp := 12;
        any_temp := any_temp-1 ;
    END IF;
        
    SELECT qtt_peticions INTO tickets_mes_anterior 
    FROM DW_tickets_resolts_mes 
    WHERE ani = any_temp AND mes = mes_temp;
         
    --calculem el percentatge 
    SELECT (tickets_mes_actual*100/tickets_mes_anterior)-100 INTO RSP 
    FROM dual;
    
    --Tractament Excepcions
    EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := NULL; --No existeix cap entrada pel mes actual o anterior
        WHEN ZERO_DIVIDE THEN RSP := 0; --Els tickets_mes_anterior es 0
            
END DW_tickets_resolts_mes_SEL;
/

--6
CREATE OR REPLACE PROCEDURE DW_servei_peticions_SEL (RSP OUT VARCHAR2) AS
BEGIN

    SELECT servei INTO RSP 
    FROM (
        SELECT servei 
        FROM DW_servei_peticions
        ORDER BY qtt_peticions DESC
    )
    WHERE ROWNUM = 1;
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := NULL; --No existeix cap entrada a la taula
 
END DW_servei_peticions_SEL;
/

--7
CREATE OR REPLACE PROCEDURE DW_incidencies_seu_any_SEL (RSP OUT VARCHAR2) AS
BEGIN
	
	SELECT seu INTO RSP 
    FROM (
        SELECT seu 
        FROM DW_incidencies_seu_any
		WHERE ani = to_char(sysdate, 'YYYY')
        ORDER BY qtt_incidencies DESC
    )
    WHERE ROWNUM = 1;
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := 0; --No existeix cap entrada a la taula
 
END DW_incidencies_seu_any_SEL;
/

--8
CREATE OR REPLACE PROCEDURE DW_hores_tickets_L3_SEL (ani_in IN INTEGER, RSP OUT INTEGER) AS
BEGIN

    SELECT qtt_hores INTO RSP
    FROM DW_hores_tickets_L3
	WHERE ani = ani_in;
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := 0; --No existeix cap entrada a la taula per aquell any
 
END DW_hores_tickets_L3_SEL;
/

--9
CREATE OR REPLACE PROCEDURE DW_incidencies_PM_SEL (RSP OUT INTEGER) AS
BEGIN

    SELECT qtt_incidencies INTO RSP
    FROM DW_incidencies_PM
	WHERE ani = to_char(sysdate, 'YYYY');
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := 0; --No existeix cap entrada a la taula per aquell any
 
END DW_incidencies_PM_SEL;
/

--10
CREATE OR REPLACE PROCEDURE DW_sms_no_respostos_SEL (RSP OUT INTEGER) AS
BEGIN

    SELECT (qtt_tickets_no_respostos/qtt_tickets*100) INTO RSP 
    FROM DW_sms_no_respostos
	WHERE ani = to_char(sysdate, 'YYYY');
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := 0; --No existeix cap entrada a la taula per aquell any
 
END DW_sms_no_respostos_SEL;
/

--11
CREATE OR REPLACE PROCEDURE DW_tickets_tancats_SEL (RSP OUT INTEGER) AS
BEGIN

    SELECT qtt_tancats INTO RSP 
    FROM DW_tickets_tancats;
   
   --Tractament Excepcions
   EXCEPTION			
        WHEN NO_DATA_FOUND THEN  RSP := 0; --No existeix cap entrada a la taula
 
END DW_tickets_tancats_SEL;
/

--12
CREATE OR REPLACE PROCEDURE DW_tickets_per_canal_SEL (mes_in IN VARCHAR2, ani_in IN VARCHAR2, pais_in IN VARCHAR2) AS
can va_params;
percentatge va_params;

BEGIN

	SELECT canal, qtt_tickets_canal/qtt_tickets_total*100 BULK COLLECT INTO can, percentatge
	FROM DW_tickets_per_canal
	WHERE mes = mes_in AND ani = ani_in and pais = pais_in;
    
    FOR indx IN 1..can.count
    LOOP    
        dbms_output.put_line(can(indx) || ' : ' || percentatge(indx));   
    END LOOP;
    
END DW_tickets_per_canal_SEL;
/