/*-----------------------DROP----------------------*/
/*------------------------------------------------*/
/*
DROP PROCEDURE pais_alta;
DROP PROCEDURE pais_baixa;
DROP PROCEDURE seu_alta;
DROP PROCEDURE seu_baixa;
DROP PROCEDURE usuari_alta;
DROP PROCEDURE usuari_baixa;
DROP PROCEDURE usuari_modif_seu;
DROP PROCEDURE interaccio_alta;
DROP PROCEDURE nivellsuport_alta;
DROP PROCEDURE nivellsuport_baixa;
DROP PROCEDURE grupsuport_alta;
DROP PROCEDURE grupsuport_baixa;
DROP PROCEDURE grupsuport_modif_nom;
DROP PROCEDURE tecnic_alta;
DROP PROCEDURE tecnic_baixa;
DROP PROCEDURE tecnic_modif_grup;
DROP PROCEDURE prioritat_alta;
DROP PROCEDURE prioritat_baixa;
DROP PROCEDURE grupservei_alta;
DROP PROCEDURE grupservei_baixa;
DROP PROCEDURE servei_alta;
DROP PROCEDURE servei_baixa;
DROP PROCEDURE servei_modif_descripcio;
DROP PROCEDURE servei_modif_grup;
DROP PROCEDURE servei_modif_temps;
DROP PROCEDURE servei_modif_prioritat;
DROP PROCEDURE ofertagrupservei_alta;
DROP PROCEDURE ofertagrupservei_baixa;
DROP PROCEDURE tipusticket_alta;
DROP PROCEDURE tipusticket_baixa;
DROP PROCEDURE canal_alta;
DROP PROCEDURE canal_baixa;
DROP PROCEDURE creacioticket_alta;
DROP PROCEDURE creacioticket_baixa;
DROP PROCEDURE ticket_alta;
DROP PROCEDURE ticket_baixa;
DROP PROCEDURE ticket_modif_creacio;
DROP PROCEDURE ticket_modif_canal;
DROP PROCEDURE assigticketgrup_alta;
DROP PROCEDURE assigticketgrup_baixa;
DROP PROCEDURE estatticket_alta;
DROP PROCEDURE estatticket_baixa;
DROP PROCEDURE canviestat_alta;
DROP PROCEDURE estatsms_alta;
DROP PROCEDURE estatsms_baixa;
DROP PROCEDURE missatge_alta;
DROP PROCEDURE missatge_modif_estat;
*/
/*----------------------CREATE---------------------*/
/*------------------------------------------------*/

--PAIS
CREATE OR REPLACE PROCEDURE pais_alta (nom_pais IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Pais 
		VALUES(nom_pais);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El pais ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'pais_alta',va_params(nom_pais),RSP);
    END;
		
END pais_alta;

/

CREATE OR REPLACE PROCEDURE pais_baixa (nom_pais IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Pais 
		WHERE nom = nom_pais;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha alguna seu ubicada en aquest pais'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'pais_baixa',va_params(nom_pais),RSP);
    END;
    
END pais_baixa;

/

--SEU
CREATE OR REPLACE PROCEDURE seu_alta (codi_seu IN VARCHAR2, direccio_seu IN VARCHAR2, tipologia_seu IN VARCHAR2, pais_seu IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Seu 
		VALUES(codi_seu, direccio_seu, tipologia_seu, pais_seu);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. La seu ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. A excepcio de la tipologia, tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El pais no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'seu_alta',va_params(codi_seu, direccio_seu, tipologia_seu, pais_seu),RSP);
    END;
	
END seu_alta;

/

CREATE OR REPLACE PROCEDURE seu_baixa (codi_seu IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Seu 
		WHERE codi = codi_seu;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Existeixen usuaris inscrits en aquesta seu'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'seu_baixa',va_params(codi_seu),RSP);
    END;

END seu_baixa;

/

CREATE OR REPLACE PROCEDURE seu_modif_tipologia (codi_seu IN VARCHAR2, tipologia_seu IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Seu 
		SET tipologia = tipologia_seu
		WHERE codi = codi_seu;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                RSP := 'ERROR: Error Inesperat';			
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'seu_modif_tipologia',va_params(codi_seu, tipologia_seu),RSP);
    END;
	
END seu_modif_tipologia;

/

--USUARI
CREATE OR REPLACE PROCEDURE usuari_alta (mail_usuari IN VARCHAR2, seu_usuari IN VARCHAR2, RSP OUT VARCHAR2) AS
usuari_inactiu INTEGER;

BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        --mirem si l'usuari ja existeix pero esta donat de baixa
		SELECT COUNT(*) INTO usuari_inactiu
		FROM Usuari
		WHERE mail = mail_usuari AND data_hora_baixa IS NOT NULL;
		
		--si es aixi, el tornem a donar d'alta
		IF usuari_inactiu > 0 THEN
			UPDATE Usuari
			SET data_hora_reg = CURRENT_TIMESTAMP, data_hora_baixa = NULL
			WHERE mail = mail_usuari;
		ELSE
			--si no, intentem inserirlo a la base de dades
			INSERT INTO Usuari 
			VALUES(mail_usuari, CURRENT_TIMESTAMP, NULL, seu_usuari);
        
		END IF;
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques usuari ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. A excepcio de la data de baixa, tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. La seu no existeix'; 
				ELSIF SQLCODE = -02290 THEN RSP := 'ERROR: RT4. El valor de la data_baixa ha de ser nul o superior a la data_alta';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'usuari_alta',va_params(mail_usuari, seu_usuari),RSP);
    END;
	
END usuari_alta;

/

CREATE OR REPLACE PROCEDURE usuari_baixa (mail_usuari IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        UPDATE Usuari 
		SET data_hora_baixa = CURRENT_TIMESTAMP
		WHERE mail = mail_usuari;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                RSP := 'ERROR: Error Inesperat: ';			
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'usuari_baixa',va_params(mail_usuari),RSP);
    END;

END usuari_baixa;

/

CREATE OR REPLACE PROCEDURE usuari_modif_seu (mail_usuari IN VARCHAR2, seu_usuari IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Usuari 
		SET seu = seu_usuari
		WHERE mail = mail_usuari;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. La seu no pot ser nula';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. La seu no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'usuari_modif_seu',va_params(mail_usuari, seu_usuari),RSP);
    END;

END usuari_modif_seu;

/

--INTERACCIO
CREATE OR REPLACE PROCEDURE interaccio_alta (usuari_interaccio IN VARCHAR2, accio IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Interaccio 
		VALUES(usuari_interaccio, CURRENT_TIMESTAMP, accio);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aquesta combinacio (usuari - instant) ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'interaccio_alta',va_params(usuari_interaccio, accio),RSP);
    END;

END interaccio_alta;

/

--NIVELLSUPORT
CREATE OR REPLACE PROCEDURE nivellsuport_alta (nivell_nivellsuport IN VARCHAR2, valor_nivellsuport IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO NivellSuport 
		VALUES(nivell_nivellsuport, valor_nivellsuport);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El nivell ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'nivellsuport_alta',va_params(nivell_nivellsuport),RSP);
    END;
		
END nivellsuport_alta;

/

CREATE OR REPLACE PROCEDURE nivellsuport_baixa (nivell_nivellsuport IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM NivellSuport 
		WHERE nivell = nivell_nivellsuport;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha alguna grup de suport al que correspon aquest nivell'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'nivellsuport_baixa',va_params(nivell_nivellsuport),RSP);
    END;

END nivellsuport_baixa;

/


--GRUPSUPORT
CREATE OR REPLACE PROCEDURE grupsuport_alta (codi_grupsuport IN VARCHAR2, nom_grupsuport IN VARCHAR2, nivell_grupsuport IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO GrupSuport 
		VALUES(codi_grupsuport, nom_grupsuport, nivell_grupsuport);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques grup ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El nivell no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'grupsuport_alta',va_params(codi_grupsuport, nom_grupsuport, nivell_grupsuport),RSP);
    END;

END grupsuport_alta;

/

CREATE OR REPLACE PROCEDURE grupsuport_baixa (codi_grupsuport IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM GrupSuport 
		WHERE codi = codi_grupsuport;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest grup esta relacionat amb algun ticket o servei'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'grupsuport_baixa',va_params(codi_grupsuport),RSP);
    END;

END grupsuport_baixa;

/

CREATE OR REPLACE PROCEDURE grupsuport_modif_nom (codi_grupsuport IN VARCHAR2, nom_grupsuport IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE GrupSuport 
		SET nom = nom_grupsuport
		WHERE codi = codi_grupsuport;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El nom no pot ser nul';	
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'grupsuport_modif_nom',va_params(codi_grupsuport, nom_grupsuport),RSP);
    END;

END grupsuport_modif_nom;

/


--TECNIC
CREATE OR REPLACE PROCEDURE tecnic_alta (mail_tecnic IN VARCHAR2, grup_tecnic IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Tecnic 
		VALUES(mail_tecnic, grup_tecnic);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques tecnic ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El grup no existeix o el tecnic no es cap usuari'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'tecnic_alta',va_params(mail_tecnic, grup_tecnic),RSP);
    END;

END tecnic_alta;

/

CREATE OR REPLACE PROCEDURE tecnic_baixa (mail_tecnic IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Tecnic 
		WHERE mail = mail_tecnic;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest tecnic esta relacionat amb algun canvi d`estat d`un ticket'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'tecnic_baixa',va_params(mail_tecnic),RSP);
    END;

END tecnic_baixa;

/

CREATE OR REPLACE PROCEDURE tecnic_modif_grup (mail_tecnic IN VARCHAR2, grup_tecnic IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Tecnic 
		SET grup = grup_tecnic
		WHERE mail = mail_tecnic;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El grup no pot ser nul';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El grup no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'tecnic_modif_grup',va_params(mail_tecnic, grup_tecnic),RSP);
    END;

END tecnic_modif_grup;

/


--PRIORITAT
CREATE OR REPLACE PROCEDURE prioritat_alta (nivell_prioritat IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Prioritat 
		VALUES(nivell_prioritat);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. La prioritat ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'prioritat_alta',va_params(nivell_prioritat),RSP);
    END;

END prioritat_alta;

/

CREATE OR REPLACE PROCEDURE prioritat_baixa (nivell_prioritat IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Prioritat 
		WHERE prioritat = nivell_prioritat;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha algun ticket o servei amb aquesta prioritat'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'prioritat_baixa',va_params(nivell_prioritat),RSP);
    END;

END prioritat_baixa;

/


--GRUPSERVEI
CREATE OR REPLACE PROCEDURE grupservei_alta (grup_grupservei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO GrupServei 
		VALUES(grup_grupservei);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El grup ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'grupservei_alta',va_params(grup_grupservei),RSP);
    END;

END grupservei_alta;

/

CREATE OR REPLACE PROCEDURE grupservei_baixa (grup_grupservei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM GrupServei 
		WHERE grup = grup_grupservei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha alguna grup de suport que ofereix aquest grup de serveis'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'grupservei_baixa',va_params(grup_grupservei),RSP);
    END;

END grupservei_baixa;

/


--SERVEI
CREATE OR REPLACE PROCEDURE servei_alta (codi_servei IN VARCHAR2, descripcio_servei IN VARCHAR2, grup_servei IN VARCHAR2, temps_mig_servei IN INTEGER, prioritat_servei IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Servei 
		VALUES(codi_servei, descripcio_servei, grup_servei, temps_mig_servei, prioritat_servei);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques servei ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. A excepcio de la descripcio, tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El grup del servei o la prioritat no existeixen'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_alta',va_params(codi_servei, descripcio_servei, grup_servei, temps_mig_servei, prioritat_servei),RSP);
    END;

END servei_alta;

/

CREATE OR REPLACE PROCEDURE servei_baixa (codi_servei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Servei 
		WHERE codi = codi_servei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest servei esta relacionat amb algun ticket'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_baixa',va_params(codi_servei),RSP);
    END;

END servei_baixa;

/

CREATE OR REPLACE PROCEDURE servei_modif_descripcio (codi_servei IN VARCHAR2, descripcio_servei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Servei 
		SET descripcio = descripcio_servei
		WHERE codi = codi_servei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				RSP := 'ERROR: Error Inesperat';					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_modif_descripcio',va_params(codi_servei, descripcio_servei),RSP);
    END;

END servei_modif_descripcio;

/

CREATE OR REPLACE PROCEDURE servei_modif_grup (codi_servei IN VARCHAR2, grup_servei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Servei 
		SET grup = grup_servei
		WHERE codi = codi_servei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El grup no pot ser nul';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El grup no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_modif_grup',va_params(codi_servei, grup_servei),RSP);
    END;

END servei_modif_grup;

/

CREATE OR REPLACE PROCEDURE servei_modif_temps (codi_servei IN VARCHAR2, temps_mig_servei IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Servei 
		SET temps_mig = temps_mig_servei
		WHERE codi = codi_servei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El temps mig no pot ser nul';	
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_modif_temps',va_params(codi_servei, temps_mig_servei),RSP);
    END;

END servei_modif_temps;

/

CREATE OR REPLACE PROCEDURE servei_modif_prioritat (codi_servei IN VARCHAR2, prioritat_servei IN INTEGER, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Servei 
		SET prioritat = prioritat_servei
		WHERE codi = codi_servei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. LA prioritat no pot ser nula';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. LA prioritat no existeix'; 				
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'servei_modif_prioritat',va_params(codi_servei, prioritat_servei),RSP);
    END;
	
END servei_modif_prioritat;

/


--OFERTAGRUPSERVEI
CREATE OR REPLACE PROCEDURE ofertagrupservei_alta (grup_ofertagrupservei IN VARCHAR2, servei_ofertagrupservei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO OfertaGrupServei 
		VALUES(grup_ofertagrupservei, servei_ofertagrupservei);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El conjunt (grup - servei) ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ofertagrupservei_alta',va_params(grup_ofertagrupservei, servei_ofertagrupservei),RSP);
    END;

END ofertagrupservei_alta;

/

CREATE OR REPLACE PROCEDURE ofertagrupservei_baixa (grup_ofertagrupservei IN VARCHAR2, servei_ofertagrupservei IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM OfertaGrupServei 
		WHERE grup = grup_ofertagrupservei AND servei = servei_ofertagrupservei;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. El servei o el grup no existeixen'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ofertagrupservei_baixa',va_params(grup_ofertagrupservei, servei_ofertagrupservei),RSP);
    END;

END ofertagrupservei_baixa;

/


--TIPUSTICKET
CREATE OR REPLACE PROCEDURE tipusticket_alta (tipus_tipusticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO TipusTicket 
		VALUES(tipus_tipusticket);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El tipus ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'tipusticket_alta',va_params(tipus_tipusticket),RSP);
    END;

END tipusticket_alta;

/

CREATE OR REPLACE PROCEDURE tipusticket_baixa (tipus_tipusticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM TipusTicket 
		WHERE tipus = tipus_tipusticket;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha algun ticket al que correspon aquest tipus'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log 
		VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'tipusticket_baixa',va_params(tipus_tipusticket),RSP);
    END;

END tipusticket_baixa;

/


--CANAL
CREATE OR REPLACE PROCEDURE canal_alta (tipus_canal IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Canal 
		VALUES(tipus_canal);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El canal ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'canal_alta',va_params(tipus_canal),RSP);
    END;

END canal_alta;

/

CREATE OR REPLACE PROCEDURE canal_baixa (tipus_canal IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM Canal 
		WHERE canal = tipus_canal;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha algun ticket al que correspon aquest canal'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'canal_baixa',va_params(tipus_canal),RSP);
    END;

END canal_baixa;

/


--CREACIOTICKET
CREATE OR REPLACE PROCEDURE creacioticket_alta (metode_creacioticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO CreacioTicket 
		VALUES(metode_creacioticket);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. El metode de creacio ja existeix';
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'creacioticket_alta',va_params(metode_creacioticket),RSP);
    END;

END creacioticket_alta;

/

CREATE OR REPLACE PROCEDURE creacioticket_baixa (metode_creacioticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM CreacioTicket 
		WHERE metode = metode_creacioticket;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Hi ha algun ticket al que correspon aquest metode de creacio'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'creacioticket_baixa',va_params(metode_creacioticket),RSP);
    END;

END creacioticket_baixa;

/


--TICKET
CREATE OR REPLACE PROCEDURE ticket_alta (numero_ticket IN VARCHAR2, servei_ticket IN VARCHAR2, prioritat_ticket IN VARCHAR2, tipus_ticket IN VARCHAR2, canal_ticket IN VARCHAR2, creacio_ticket IN VARCHAR2, usuari_ticket IN VARCHAR2, RSP OUT VARCHAR2) AS
seu_dw VARCHAR2 (20 CHAR);
pais_dw VARCHAR2 (50 CHAR);
llista_canals_dw va_params;

BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO Ticket 
		VALUES(numero_ticket, CURRENT_TIMESTAMP, servei_ticket, prioritat_ticket, tipus_ticket, canal_ticket, creacio_ticket, usuari_ticket);
        
		RSP := 'OK';
    
		/*Bloc 2: Crida als procediments del data warehouse*/
		--parametres comuns per a varies funcions del DW
		SELECT Seu.codi INTO seu_dw
		FROM Seu INNER JOIN Usuari ON Usuari.seu = Seu.codi
		WHERE Usuari.mail = usuari_ticket;
		
		/*DW_usuari_mes_incidencies_INC (usuari)*/
		IF (tipus_ticket = 'Incidencia') THEN
				DW_usuari_mes_incidencies_INC (usuari_ticket);
		END IF;
			
		/*DW_top10_peticions_seu_INC (seu, servei)*/
		IF (tipus_ticket = 'Peticio') THEN
			
				DW_top10_peticions_seu_INC (seu_dw, servei_ticket);
		END IF;
		
		/*DW_servei_peticions_INC (servei)*/
		IF (tipus_ticket = 'Peticio') THEN	
				DW_servei_peticions_INC (servei_ticket);
		END IF;
		
		/*DW_incidencies_seu_any_INC (seu)*/
		IF (tipus_ticket = 'Incidencia') THEN	
				DW_incidencies_seu_any_INC (seu_dw);
		END IF;
		
		/*DW_sms_no_respostos_INC*/
		DW_sms_no_respostos_INC;
		
		/*DW_tickets_per_canal_INC (pais, canal, noms_canals[va_params])*/
		--seleccionem el pais on esta ubicda la seu al que pertany l`usuari
		SELECT Seu.pais INTO pais_dw
		FROM Seu INNER JOIN Usuari ON Usuari.seu = Seu.codi
		WHERE Usuari.mail = usuari_ticket;
		
		--seleccionem un llistat dels canals existents al sistema
		SELECT canal BULK COLLECT INTO llista_canals_dw
		FROM Canal;
		
		DW_tickets_per_canal_INC(pais_dw, canal_ticket, llista_canals_dw);
	
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques ticket ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El servei, prioritat, tipus, canal, creacio o usuari no existeixen'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ticket_alta',va_params(numero_ticket, CURRENT_TIMESTAMP, servei_ticket, prioritat_ticket, tipus_ticket, canal_ticket, creacio_ticket, usuari_ticket),RSP);
    END;
		
END ticket_alta;

/

CREATE OR REPLACE PROCEDURE ticket_baixa (numero_ticket IN VARCHAR2, RSP OUT VARCHAR2) AS
usuari_dw VARCHAR2 (50 CHAR);
seu_dw VARCHAR2 (20 CHAR);
servei_dw VARCHAR2 (20 CHAR);
pais_dw VARCHAR2 (50 CHAR);
canal_dw VARCHAR2 (20 CHAR);
tipus_dw VARCHAR2 (20 CHAR);

BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN
	
		--parametres comuns per a varies funcions del DW
		SELECT servei, tipus, canal, usuari INTO servei_dw, tipus_dw, canal_dw, usuari_dw 
		FROM Ticket
		WHERE numero = numero_ticket;
		
		SELECT seu INTO seu_dw
		FROM Usuari
		WHERE mail = usuari_dw;
		
		SELECT pais INTO pais_dw
		FROM Seu
		WHERE codi = seu_dw;
	
        --Delete
        DELETE FROM Ticket 
		WHERE numero = numero_ticket;
        
		RSP := 'OK';
		
		/*Bloc 2: Crida als procediments del data warehouse*/
		
		/*DW_usuari_mes_incidencies_DEC (usuari)*/
		IF (tipus_dw = 'Incidencia') THEN
				DW_usuari_mes_incidencies_DEC (usuari_dw);
		END IF;
		
		/*DW_top10_peticions_seu_DEC (seu, servei)*/
		IF (tipus_dw = 'Peticio') THEN
				DW_top10_peticions_seu_DEC (seu_dw, servei_dw);
		END IF;
		
		/*DW_servei_peticions_DEC (servei)*/
		IF (tipus_dw = 'Peticio') THEN
				DW_servei_peticions_DEC (servei_dw);
		END IF;
		
		/*DW_incidencies_seu_any_DEC (seu)*/
		IF (tipus_dw = 'Incidencia') THEN
				DW_incidencies_seu_any_DEC (seu_dw);
		END IF;
		
		/*DW_tickets_tancats_DEC*/
		DW_tickets_tancats_DEC;
		
		/*DW_tickets_per_canal_DEC (pais, canal)*/
		DW_tickets_per_canal_DEC(pais_dw, canal_dw);
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest ticket esta relacionat amb algun canvi d`estat o grup de suport'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ticket_baixa',va_params(numero_ticket),RSP);
    END;
    
END ticket_baixa;

/

CREATE OR REPLACE PROCEDURE ticket_modif_canal (numero_ticket IN VARCHAR2, canal_ticket IN VARCHAR2, RSP OUT VARCHAR2) AS
canal_anterior VARCHAR2 (20 CHAR);
pais_ticket VARCHAR2 (50 CHAR);
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN
	
		--desem el canal anterior per modificar despres les taules del magatzem
		SELECT canal INTO canal_anterior
		FROM ticket
		WHERE numero = numero_ticket;
	
	
        --Update
        UPDATE Ticket 
		SET canal = canal_ticket
		WHERE numero = numero_ticket;
        
		RSP := 'OK';
		
		/*Bloc 2: Crida als procediments del data warehouse*/
			
		/*DW_tickets_per_canal_MOD*/
		
		SELECT Seu.pais INTO pais_ticket
		FROM Ticket INNER JOIN Usuari ON Ticket.usuari = Usuari.mail 
			INNER JOIN Seu ON Seu.codi = Usuari.seu
		WHERE Ticket.numero = numero_ticket;
		
		DW_tickets_per_canal_MOD(pais_ticket, canal_anterior, canal_ticket);
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El canal no pot ser nul';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El canal no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ticket_modif_canal',va_params(numero_ticket, canal_ticket),RSP);
    END;
	
END ticket_modif_canal;

/

CREATE OR REPLACE PROCEDURE ticket_modif_creacio (numero_ticket IN VARCHAR2, creacio_ticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Ticket 
		SET creacio = creacio_ticket
		WHERE numero = numero_ticket;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. El metode de creacio no pot ser nul';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El metode de creacio no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'ticket_modif_creacio',va_params(numero_ticket, creacio_ticket),RSP);
    END;
	
END ticket_modif_creacio;

/


--ASSIGTICKETGRUP
CREATE OR REPLACE PROCEDURE assigticketgrup_alta (ticket_assigticketgrup IN VARCHAR2, grup_assigticketgrup IN VARCHAR2, RSP OUT VARCHAR2) AS
    nivell_actual INTEGER;
    nivell_futur INTEGER;
    oferta_servei INTEGER;
	data_assignacio_L3 TIMESTAMP;
    servei_no_ofert EXCEPTION;
    nivell_decreixent EXCEPTION;
    nivell_dw VARCHAR2 (20 CHAR);
    tipus_dw VARCHAR2 (20 CHAR);
    
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        --Restriccions textuals
            --nivell del grup que es vol assignar
        SELECT nivellsuport.valor INTO nivell_futur 
		FROM grupsuport INNER JOIN nivellsuport ON nivellsuport.nivell = grupsuport.nivell
		WHERE grupsuport.codi = grup_assigticketgrup;
		
            --nivell del grup que te actualment assignat
        SELECT MAX (nivellsuport.valor) INTO nivell_actual --agafem el nivell del grup assignat actualment al ticket
        FROM assigticketgrup INNER JOIN grupsuport ON assigticketgrup.grup = grupsuport.codi
			INNER JOIN nivellsuport ON grupsuport.nivell = nivellsuport.nivell
        WHERE assigticketgrup.ticket = ticket_assigticketgrup
        ORDER BY assigticketgrup.data_hora DESC;
		
        IF nivell_futur < nivell_actual THEN
            RAISE nivell_decreixent;
        END IF;
        
            --servei que solicita el ticket
            SELECT COUNT (*) INTO oferta_servei
            FROM ticket
            WHERE numero = ticket_assigticketgrup AND servei IN (
                SELECT servei
                FROM ofertagrupservei 
                WHERE grup = grup_assigticketgrup
            );
        
        IF oferta_servei < 1 THEN
            RAISE servei_no_ofert;
        END IF;
        
        --Insert
		INSERT INTO AssigTicketGrup 
		VALUES(ticket_assigticketgrup, grup_assigticketgrup, CURRENT_TIMESTAMP);
        
		RSP := 'OK';
    
		/*Bloc 2: Crida als procediments del data warehouse*/
		
		/*DW_hores_tickets_L3_INC*/
        SELECT nivell INTO nivell_dw
        FROM grupsuport 
        WHERE codi = grup_assigticketgrup;
        
		IF (nivell_dw = 'Problem Management') THEN
			--el nou grup es de nivell 'Problem management'. Comptem les hores que el ticket ha passat amb el grup L3
			SELECT data_hora INTO data_assignacio_L3
			FROM (
				SELECT data_hora, rownum rnum
				FROM (
					SELECT data_hora 
					FROM assigticketgrup
					WHERE ticket = ticket_assigticketgrup
					ORDER BY data_hora DESC
				)
			)
			WHERE rnum = 2;
			
			DW_hores_tickets_L3_INC(data_assignacio_L3);
		
		/*DW_incidencies_PM_INC*/
        SELECT tipus INTO tipus_dw
        FROM ticket 
        WHERE numero = ticket_assigticketgrup;
			IF (tipus_dw = 'Incidencia') THEN
				--l`assignacio es a un grup PM i el ticket es de tipus incidencia
				DW_incidencies_PM_INC;
			END IF;
		
		END IF;
	
		--Tractament Excepcions
		EXCEPTION			
            WHEN nivell_decreixent THEN
                RSP := 'ERROR: Restriccio textual. El nivell del grup que s`intenta assignar al ticket es inferior al nivell del grup que el ticket ja te assignat actualment'; 
               
            WHEN servei_no_ofert THEN
                RSP := 'ERROR: Restriccio textual. El grup que s`intenta assignar al ticket no ofereix el servei que el ticket demana'; 
            
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aquesta assignacio ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. El grup o el ticket no existeixen'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'assigticketgrup_alta',va_params(ticket_assigticketgrup, grup_assigticketgrup),RSP);
    END;
	
END assigticketgrup_alta;

/

CREATE OR REPLACE PROCEDURE assigticketgrup_baixa (ticket_assigticketgrup IN VARCHAR2, grup_assigticketgrup IN VARCHAR2, RSP OUT VARCHAR2) AS
nivell_dw VARCHAR2 (20 CHAR);
tipus_dw VARCHAR2 (20 CHAR);
BEGIN 
    	
	/*Bloc 1: Eliminacio de la taula*/
	BEGIN

        --Delete
        DELETE FROM AssigTicketGrup 
		WHERE ticket = ticket_assigticketgrup AND grup = grup_assigticketgrup;
        
		RSP := 'OK';
		
		/*Bloc 2: Crida als procediments del data warehouse*/
		
		/*DW_incidencies_PM_DEC*/
        SELECT nivell INTO nivell_dw
        FROM grupsuport 
        WHERE codi = grup_assigticketgrup;
        
        SELECT tipus INTO tipus_dw
        FROM ticket 
        WHERE numero = ticket_assigticketgrup;
        
		IF (nivell_dw = 'Problem Management' AND tipus_dw = 'Incidencia') THEN
			DW_incidencies_PM_DEC;
		END IF;
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				RSP := 'ERROR: Error Inesperat';
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'assigticketgrup_baixa',va_params(ticket_assigticketgrup, grup_assigticketgrup),RSP);
    END;

END assigticketgrup_baixa;

/


--ESTATTICKET
CREATE OR REPLACE PROCEDURE estatticket_alta (estat_estatticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO EstatTicket 
		VALUES(estat_estatticket);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques estat ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'estatticket_alta',va_params(estat_estatticket),RSP);
    END;

END estatticket_alta;

/

CREATE OR REPLACE PROCEDURE estatticket_baixa (estat_estatticket IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		DELETE FROM EstatTicket 
		WHERE estat = estat_estatticket;
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest estat esta relacionat amb algun ticket'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'estatticket_baixa',va_params(estat_estatticket),RSP);
    END;

END estatticket_baixa;

/


--CANVIESTAT
CREATE OR REPLACE PROCEDURE canviestat_alta (ticket_canviestat IN VARCHAR2, tecnic_canviestat IN VARCHAR2, estat_canviestat IN VARCHAR2, RSP OUT VARCHAR2) AS
grup_tecnic VARCHAR2 (20 CHAR);
grup_actual_ticket VARCHAR2 (20 CHAR);
tecnic_prohibit EXCEPTION;
tipus_dw VARCHAR2 (20 CHAR);
temps_mig_dw INTEGER;
nivell_grup_dw VARCHAR (20 CHAR);
data_assignacio_L3 TIMESTAMP;
data_creacio_dw TIMESTAMP;
usuari_dw VARCHAR2 (50 CHAR);
prioritat_dw INTEGER;
seu_dw VARCHAR2 (20 CHAR);
servei_dw VARCHAR2 (20 CHAR);
pais_dw VARCHAR2 (50 CHAR);
canal_dw VARCHAR (20 CHAR);

BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Restriccions textuals
            --grup al que pertany el tecnic que vol efectuar el canvi d'estat
        SELECT grup INTO grup_tecnic
        FROM tecnic 
        WHERE mail = tecnic_canviestat;
		
            --grup assignat actualment al ticket
        SELECT grup INTO grup_actual_ticket
        FROM (
            SELECT grup
            FROM assigticketgrup
            WHERE ticket = ticket_canviestat
            ORDER BY data_hora DESC
        )
        WHERE ROWNUM = 1;
		
			--el tecnic que intenta efectuar el canvi d`estat, no esta assignat al ticket actualment
        IF grup_tecnic != grup_actual_ticket THEN
            RAISE tecnic_prohibit;
        END IF;
		
		
		--Insert
		INSERT INTO CanviEstat 
		VALUES(ticket_canviestat, CURRENT_TIMESTAMP, tecnic_canviestat, estat_canviestat);
        
		RSP := 'OK';
    
		/*Bloc 2: Crida als procediments del data warehouse*/
		
		--parametres comuns per a varies funcions del DW 
		--(prioritat, data_creacio, usuari, seu, servei, tipus, canal i pais)
		SELECT prioritat, data_hora_creacio, usuari, servei, tipus, canal 
            INTO prioritat_dw, data_creacio_dw, usuari_dw, servei_dw, tipus_dw, canal_dw 
		FROM Ticket
		WHERE numero = ticket_canviestat;
		
        SELECT seu INTO seu_dw
        FROM Usuari
        WHERE mail = usuari_dw;
        
		SELECT pais INTO pais_dw
		FROM Seu
		WHERE codi = seu_dw;
		
		/*DW_temps_incidencies_prio_INC (prioritat, data_creacio)*/
			IF (tipus_dw = 'Incidencia' AND estat_canviestat = 'Resolt') THEN
				DW_temps_incidencies_prio_INC (prioritat_dw, data_creacio_dw);
			END IF;
			
		/*DW_peticions_sobre_temps_INC (temps_mig, data_creacio, pais)*/	
			IF (tipus_dw = 'Peticio' AND estat_canviestat = 'Resolt') THEN
				--temps_mig de resolucio pel servei que solicita el ticket
				SELECT Servei.temps_mig INTO temps_mig_dw
				FROM Ticket INNER JOIN Servei ON Ticket.servei = Servei.codi
				WHERE Ticket.numero = ticket_canviestat;
				
				DW_peticions_sobre_temps_INC (temps_mig_dw, data_creacio_dw, pais_dw);
			END IF;
			
		/*DW_usuari_mes_incidencies_DEC (usuari)*/
			IF (tipus_dw = 'Incidencia' AND estat_canviestat = 'Cancelat') THEN
				DW_usuari_mes_incidencies_DEC (usuari_dw);
			END IF;
			
		/*DW_top10_peticions_seu_DEC (seu, servei)*/
			IF (tipus_dw = 'Peticio' AND estat_canviestat = 'Cancelat') THEN
				DW_top10_peticions_seu_DEC (seu_dw, servei_dw);
			END IF;
		
		/*DW_tickets_resolts_mes_INC*/
			IF (estat_canviestat = 'Resolt') THEN
				DW_tickets_resolts_mes_INC;
			END IF;
		
		/*DW_servei_peticions_DEC (servei)*/
			IF (tipus_dw = 'Peticio' AND estat_canviestat = 'Cancelat') THEN
				DW_servei_peticions_DEC (servei_dw);
			END IF;
		
		/*DW_incidencies_seu_any_DEC (seu)*/
			IF (tipus_dw = 'Incidencia' AND estat_canviestat = 'Cancelat') THEN
				DW_servei_peticions_DEC (seu_dw);
			END IF;
		
		/*DW_hores_tickets_L3_INC*/
			SELECT nivell INTO nivell_grup_dw
			FROM GrupSuport
			WHERE codi = grup_actual_ticket;
		
			IF (estat_canviestat = 'Resolt' AND nivell_grup_dw = 'L3') THEN
				SELECT data_hora INTO data_assignacio_L3
				FROM (
					SELECT data_hora 
					FROM assigticketgrup
					WHERE ticket = ticket_canviestat
					ORDER BY data_hora DESC
				)
				WHERE ROWNUM = 1;
			
				DW_hores_tickets_L3_INC(data_assignacio_L3);
			END IF;
				
		/*DW_tickets_tancats_INC*/
			IF (estat_canviestat = 'Resolt' OR estat_canviestat = 'Cancelat') THEN
				DW_tickets_tancats_INC;
			END IF;
		
		/*DW_tickets_per_canal_DEC (pais, canal)*/
			IF (estat_canviestat = 'Cancelat') THEN
				DW_tickets_per_canal_DEC (pais_dw, canal_dw);
			END IF;
		
		
		--Tractament Excepcions
		EXCEPTION
			WHEN tecnic_prohibit THEN
                RSP := 'ERROR: Restriccio textual. El tecnic no pertany al grup que actualment s`encarrega del ticket'; 
               		
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aquest canvi d`estat ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'canviestat_alta',va_params(ticket_canviestat, tecnic_canviestat, estat_canviestat),RSP);
    END;
	
END canviestat_alta;

/


--ESTATSMS
CREATE OR REPLACE PROCEDURE estatsms_alta (estat_estatsms IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		INSERT INTO EstatSms 
		VALUES(estat_estatsms);
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques estat ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'estatsms_alta',va_params(estat_estatsms),RSP);
    END;

END estatsms_alta;

/

CREATE OR REPLACE PROCEDURE estatsms_baixa (estat_estatsms IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Insert
		DELETE FROM EstatSms 
		WHERE estat = estat_estatsms;
        
		RSP := 'OK';
    
		--Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
                IF SQLCODE = -02292 THEN RSP := 'ERROR: Violacio clau forana. Aquest estat esta relacionat amb algun missatge'; 
				ELSE RSP := 'ERROR: Error Inesperat';			
				END IF;
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'estatsms_baixa',va_params(estat_estatsms),RSP);
    END;
		
END estatsms_baixa;

/


--MISSATGE
CREATE OR REPLACE PROCEDURE missatge_alta (codi_missatge IN VARCHAR2, emissor_missatge IN VARCHAR2, estat_missatge IN VARCHAR2, ticket_missatge IN VARCHAR2, RSP OUT VARCHAR2) AS
usuari_diferent EXCEPTION;
usuari_ticket VARCHAR2 (50 CHAR);
qtt_sms_usuari_dw INTEGER;

BEGIN 
    	
	/*Bloc 1: Insercio a la taula*/
	BEGIN
        
		--Restriccions textuals
		IF emissor_missatge != 'SYS' THEN
			
			--seleccionem l'usuari que ha generat el ticket associat al missatge
			SELECT usuari INTO usuari_ticket
			FROM ticket
			WHERE numero = ticket_missatge;
			
			IF usuari_ticket != emissor_missatge THEN
				RAISE usuari_diferent;
			END IF;		
		END IF;
		
		--Insert
		INSERT INTO Missatge  VALUES(codi_missatge, CURRENT_TIMESTAMP, emissor_missatge, estat_missatge, ticket_missatge);
        
		RSP := 'OK';
    
		/*Bloc 2: Crida als procediments del data warehouse*/
			
        /*DW_sms_no_respostos_DEC*/
        SELECT COUNT (*) INTO qtt_sms_usuari_dw
        FROM missatge 
        WHERE ticket = ticket_missatge AND emissor != 'SYS';
		IF (emissor_missatge != 'SYS' AND qtt_sms_usuari_dw = 1) THEN
			--l'emissor es l'usuari i es el primer missatge que no ha estat enviat per sys. Decrementem el nombre de tickets no respostos
			DW_sms_no_respostos_DEC;	
		END IF;
	
		--Tractament Excepcions
		EXCEPTION
			WHEN usuari_diferent THEN
				RSP := 'L`emissor del missatge ha de ser SYS o l`usuari al que correspon el ticket';
					
            WHEN OTHERS THEN 
                IF SQLCODE = -00001 THEN RSP := 'ERROR: Violacio de clau primaria. Aques missatge ja existeix'; 
				ELSIF SQLCODE = -01400 THEN RSP := 'ERROR: Null. Tots els atributs han de tenir algun valor';
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;
    END;
		
	/*Bloc 3: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'missatge_alta',va_params(codi_missatge, emissor_missatge, estat_missatge, ticket_missatge),RSP);
    END;
	
END missatge_alta;

/

CREATE OR REPLACE PROCEDURE missatge_modif_estat (codi_missatge IN VARCHAR2, estat_missatge IN VARCHAR2, RSP OUT VARCHAR2) AS
BEGIN
	
	/*Bloc 1: Modificacio de la taula*/
	BEGIN

        --Update
        UPDATE Missatge 
		SET estat = estat_missatge
		WHERE codi = codi_missatge;
        
		RSP := 'OK';
		
        --Tractament Excepcions
		EXCEPTION			
            WHEN OTHERS THEN
				IF SQLCODE = -01407 THEN RSP := 'ERROR: Null. L`estat no pot ser nul';	
				ELSIF SQLCODE = -02291 THEN RSP := 'ERROR: Violacio de clau forana. L`estat no existeix'; 
				ELSE RSP := 'ERROR: Error Inesperat';
				END IF;					
    END;
		
	/*Bloc 2: Registre de la crida al Log*/
    BEGIN
        INSERT INTO Log VALUES(Log_seq.nextval, CURRENT_TIMESTAMP,'missatge_modif_estat',va_params(codi_missatge, estat_missatge),RSP);
    END;

END missatge_modif_estat;

/